// -*- C++ -*-
//
//  This file is part of Siena, a wide-area event notification system.
//  See http://www.inf.usi.ch/carzaniga/siena/
//
//  Authors: Antonio Carzaniga
//  See the file AUTHORS for full details. 
//
//  Copyright (C) 2002-2003 University of Colorado
//
//  Siena is free software: you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation, either version 3 of the License, or
//  (at your option) any later version.
//  
//  Siena is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//  
//  You should have received a copy of the GNU General Public License
//  along with Siena.  If not, see <http://www.gnu.org/licenses/>.
//
#ifndef SIENA_EXCEPTIONS_H
#define SIENA_EXCEPTIONS_H

/** \file exceptions.h 
 *
 *  This header file defines the error conditions of the Siena data
 *  model.
 **/

#include <exception>
#include <string>

using std::string;

namespace siena {

/** @brief base class for all exceptions.
 **/
class bad_constraint : public std::exception {
    string err_descr;

public:
			bad_constraint(const string& e);

    virtual		~bad_constraint() throw();
    virtual const char*	what() const throw();
};

} // end namespace siena

#endif
